--[[
LuCI - Lua Configuration Interface

Copyright 2008 Steven Barth <steven@midlink.org>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

$Id: coovachilli.lua 3548 2008-10-09 20:28:07Z Cyrus $
]]--
module("luci.controller.coovachilli", package.seeall)

function index()

	require("luci.i18n")
	local i18n = luci.i18n.translate

	local cc = entry( { "admin", "services", "coovachilli" },            cbi("coovachilli"),         i18n("coovachilli",         "CoovaChilli"),                90)
	cc.i18n = "coovachilli"
	cc.subindex = true
	
	entry( { "admin", "services", "coovachilli", "network" }, cbi("coovachilli_network"), i18n("coovachilli_network", "Network Configuration"),      10)
	entry( { "admin", "services", "coovachilli", "radius"  }, cbi("coovachilli_radius"),  i18n("coovachilli_radius",  "Radius Configuration"),       20)
	entry( { "admin", "services", "coovachilli", "auth"    }, cbi("coovachilli_auth"),    i18n("coovachilli_auth",    "UAM and MAC Authentication"), 30)

end
